{{- $existingSecret := lookup "v1" "Secret" .Release.Namespace (include "mongodb.name" .) }}
apiVersion: v1
kind: Secret
metadata:
  name: {{ template "mongodb.name" . }}
  labels:
    app.kubernetes.io/name: {{ template "mongodb.name" . }}
    helm.sh/chart: {{ .Chart.Name }}-{{ .Chart.Version }}
    app.kubernetes.io/instance: {{ .Release.Name }}
    app.kubernetes.io/managed-by: {{ .Release.Service }}
type: Opaque
data:
  MONGODB_BACKUP_USER: {{ "backup" | b64enc | quote }}
  MONGODB_CLUSTER_ADMIN_USER: {{ "clusterAdmin" | b64enc | quote }}
  MONGODB_CLUSTER_MONITOR_USER: {{ "clusterMonitor" | b64enc | quote }}
  MONGODB_USER_ADMIN_USER: {{ "userAdmin" | b64enc | quote }}
{{- if (and $existingSecret $existingSecret.data) }}
{{- if $existingSecret.data.MONGODB_BACKUP_PASSWORD }}
  MONGODB_BACKUP_PASSWORD: {{ $existingSecret.data.MONGODB_BACKUP_PASSWORD | quote }}
{{- else }}
  MONGODB_BACKUP_PASSWORD: {{ .Values.config.passwords.backup | default (randAlphaNum 24) | b64enc | quote }}
{{- end }}
{{- if $existingSecret.data.MONGODB_CLUSTER_ADMIN_PASSWORD }}
  MONGODB_CLUSTER_ADMIN_PASSWORD: {{ $existingSecret.data.MONGODB_CLUSTER_ADMIN_PASSWORD | quote }}
{{- else }}
  MONGODB_CLUSTER_ADMIN_PASSWORD: {{ .Values.config.passwords.clusterAdmin | default (randAlphaNum 24) | b64enc | quote }}
{{- end }}
{{- if $existingSecret.data.MONGODB_CLUSTER_MONITOR_PASSWORD }}
  MONGODB_CLUSTER_MONITOR_PASSWORD: {{ $existingSecret.data.MONGODB_CLUSTER_MONITOR_PASSWORD | quote }}
{{- else }}
  MONGODB_CLUSTER_MONITOR_PASSWORD: {{ .Values.config.passwords.clusterMonitor | default (randAlphaNum 24) | b64enc | quote }}
{{- end }}
{{- if $existingSecret.data.MONGODB_USER_ADMIN_PASSWORD }}
  MONGODB_USER_ADMIN_PASSWORD: {{ $existingSecret.data.MONGODB_USER_ADMIN_PASSWORD | quote }}
{{- else }}
  MONGODB_USER_ADMIN_PASSWORD: {{ .Values.config.passwords.userAdmin | default (randAlphaNum 24) | b64enc | quote }}
{{- end }}
{{- if $existingSecret.data.PMM_SERVER_API_KEY }}
  PMM_SERVER_API_KEY: {{ $existingSecret.data.PMM_SERVER_API_KEY | quote }}
{{- else }}
  PMM_SERVER_API_KEY: {{ .Values.config.passwords.pmmServerApiKey | default (randAlphaNum 24) | b64enc | quote }}
{{- end }}
{{- else }}
  MONGODB_BACKUP_PASSWORD: {{ .Values.config.passwords.backup | default (randAlphaNum 24) | b64enc | quote }}
  MONGODB_CLUSTER_ADMIN_PASSWORD: {{ .Values.config.passwords.clusterAdmin | default (randAlphaNum 24) | b64enc | quote }}
  MONGODB_CLUSTER_MONITOR_PASSWORD: {{ .Values.config.passwords.clusterMonitor | default (randAlphaNum 24) | b64enc | quote }}
  MONGODB_USER_ADMIN_PASSWORD: {{ .Values.config.passwords.userAdmin | default (randAlphaNum 24) | b64enc | quote }}
  PMM_SERVER_API_KEY: {{ .Values.config.passwords.pmmServerApiKey | default (randAlphaNum 24) | b64enc | quote }}
{{- end }}
